Map (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.util

## Class Map

- java.lang.Object
- - java.util.AbstractMap<K,V>
  - - java.util.HashMap
    - - hlt.language.util.Map

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, java.util.Map

      public class Map
      extends java.util.HashMap

  Extends HashMap with equals and hashCode methods to allow "higher-order" maps (i.e., Maps of Maps).

  NB: Of course, testing and storing a Map works only if it is immutable (nothing more is put into or removed from it after being initially filled). This is enforced by setting a lock as soon as either equals or hashCode is used on a given Map.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.util.AbstractMap

      `java.util.AbstractMap.SimpleEntry<K,V>, java.util.AbstractMap.SimpleImmutableEntry<K,V>`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Map()`
    `Map(int initialCapacity)`
    `Map(int initialCapacity, float loadFactor)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()`
    `boolean` | `equals(java.lang.Object other)`
    `int` | `hashCode()`
    `boolean` | `isLocked()`
    `void` | `lock()`
    `java.lang.Object` | `put(java.lang.Object k, java.lang.Object o)`
    `java.lang.Object` | `remove(java.lang.Object o)`

    - ### Methods inherited from class java.util.HashMap

      `clone, containsKey, containsValue, entrySet, get, isEmpty, keySet, putAll, size, values`

    - ### Methods inherited from class java.util.AbstractMap

      `toString`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Map

          public Map()

    - #### Map

          public Map(int initialCapacity)

    - #### Map

          public Map(int initialCapacity,
             float loadFactor)

  - ### Method Detail

    - #### lock

          public final void lock()

    - #### isLocked

          public final boolean isLocked()

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in interface `java.util.Map`
      Overrides:
        `hashCode` in class `java.util.AbstractMap`

    - #### equals

          public boolean equals(java.lang.Object other)

      Specified by:
        `equals` in interface `java.util.Map`
      Overrides:
        `equals` in class `java.util.AbstractMap`

    - #### clear

          public void clear()

      Specified by:
        `clear` in interface `java.util.Map`
      Overrides:
        `clear` in class `java.util.HashMap`

    - #### put

          public java.lang.Object put(java.lang.Object k,
                             java.lang.Object o)

      Specified by:
        `put` in interface `java.util.Map`
      Overrides:
        `put` in class `java.util.HashMap`

    - #### remove

          public java.lang.Object remove(java.lang.Object o)

      Specified by:
        `remove` in interface `java.util.Map`
      Overrides:
        `remove` in class `java.util.HashMap`